unit Unit1;

// Beispiel für Navigation im TMemo
// http://www.buoa.de | Norbert Simon | 09.02.2015

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Clipbrd;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
// Select All
   if (Key = Ord('A')) and (ssCtrl in Shift) then
   begin
     TMemo(Sender).SelectAll;  //  Bibliothek Clipbrd
     Key := 0;
   end;
// STRG Pos1 → Dokumentanfang
   if (Key = VK_Home) and (ssCtrl in Shift) then
   begin
     TMemo(Sender).SelStart := 0;
     TMemo(Sender).SelLength := 0;
     Key := 0;
   end;
// STRG End → Dokumentende
   if (Key = VK_End) and (ssCtrl in Shift) then
   begin
    TMemo(Sender).SelStart := Length(Memo1.Lines.Text);
    TMemo(Sender).SelLength   := 0;
    Key := 0;
   end;

// Wichtig: TMemo(Sender).CaretPos.x := ... → geht nicht, READ ONLY. Aber .CaretPos kann mit Point(x,y) beschrieben werden!

// Pos1 → Zeilenanfang
   if (Key = VK_Home) then
   begin
     TMemo(Sender).CaretPos := Point(0,TMemo(Sender).CaretPos.y);  // Zeilenposiiton auf 0 setzen
     TMemo(Sender).SelLength := 0;
     Key := 0;
   end;
// STRG End → Dokumentende
   if (Key = VK_End) and (ssCtrl in Shift) then
   begin
      TMemo(Sender).CaretPos := Point(TMemo(Sender).Lines[TMemo(Sender).CaretPos.y].Length-1,TMemo(Sender).CaretPos.y); //Zeilenposition auf Länge - 1 setzen
    TMemo(Sender).SelLength   := 0;
    Key := 0;
   end;

end;

end.
